/*
 * Copyright (C) 2021 Anton Romanov - All Rights Reserved
 * You may use, distribute and modify this code, please write to: romanov73@gmail.com.
 *
 */

package ru.ulstu.service;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import ru.ulstu.datamodel.exception.ModelingException;
import ru.ulstu.datamodel.ts.TimeSeries;
import ru.ulstu.method.Method;
import ru.ulstu.method.exponential.addtrendaddseason.AddTrendAddSeason;

import java.util.Collections;


@Service
public class TimeSeriesService {
    private static final Logger LOGGER = LoggerFactory.getLogger(TimeSeriesService.class);
    private final MethodParamBruteForce methodParamBruteForce;

    public TimeSeriesService(MethodParamBruteForce methodParamBruteForce) {
        this.methodParamBruteForce = methodParamBruteForce;
    }

    public TimeSeries getForecast(TimeSeries timeSeries, int countPoints) throws ModelingException {
        Method method;
        method = new AddTrendAddSeason();
        return method.getForecast(timeSeries, Collections.emptyList(), countPoints);
    }

    public TimeSeries smoothTimeSeries(TimeSeries timeSeries) throws ModelingException {
        return methodParamBruteForce.getSmoothedTimeSeries(timeSeries).getTimeSeries();
    }
}
